#!/bin/sh
# Copyright (c) Ramin Honary, 2023-01-18, licensed under the GNU
# General Public License (GPL) version 3 or later.

# This script creates an archive of this whole web site.

ARCHIVE_FILENAME="$1"; # Positional parameter copied but not shifted yet

export TZ=UTC;
export LC_TIME='en.US';
ARCHIVE_DATE="$(date '+%F_%H%M' ;)";

if [ -z "${ARCHIVE_FILENAME}" ]; then
  ARCHIVE_FILENAME="website-archive_${ARCHIVE_DATE}.tar.gz";
else
  shift; # Shift positional parameters now
fi;

find \
    -type d -name '.git' -prune -false -o \
    -type f -name 'manifest*.txt' -prune -false -o \
    -type f -not -name '.x.*' \
    >"manifest.txt" || exit 1

tar czvf "./${ARCHIVE_FILENAME}" -T manifest.txt;

