#!/bin/bash

# This script runs in it's own GNU Screen shell, it automates my moves
# in the "Daily Adventure" game on this server.

declare -ir Minutes=60;
declare -ir Hours=$(( 60 * Minutes ));
declare -ir Days=$(( 24 * Hours ));

declare -i EmDelay=0; ## Used to count how many actions succeeded.

dado() {
    if local report="$(date '+%F %a %T ->'; da do "${1}"; )";
    then
	echo $report;
	sleep $(( 1 * Days - 1 ));
	EmDelay=$(( EmDelay + 1 ));
	return 0;
    else
	return 1;
    fi;
}

while true; do
    declare -i EmDelay=0;
    dado granary || dado wood;
    dado bed;
    dado wood;
    dado carpentry || dado wood;
    dado bed;
    dado farm || dado wood;
    dado bed;
    sleep "${EmDelay}";
      ## ^ Delay in case all above fails, this
      ## ^ prevents a high speed infinite loop.
done;
