(server-start)
(menu-bar-mode 0)
;;(tool-bar-mode 0)
;;(scroll-bar-mode 0)
;;(set-fringe-style 0)
(column-number-mode 1)
(toggle-truncate-lines 1)
(setq indent-tabs-mode nil)
(setq frame-inherited-parameters '(left-fringe right-fringe))
(setq truncate-partial-width-windows 100)
(setq initial-scratch-message nil)
(setq make-backup-files nil)
(setq blink-matching-paren t)
(setq register-preview-delay 0)
(setq inhibit-startup-screen nil) ;; Startup screen is defined below.

(global-set-key (kbd "C-x r %") #'replace-rectangle)
(global-set-key (kbd "C-c w s") #'delete-trailing-whitespace)
(global-set-key (kbd "C-c w t") #'untabify)
(global-set-key (kbd "C-c b u") #'unbury-buffer)
(global-set-key (kbd "C-x C-b") #'ibuffer) ;; replaces 'list-buffers
(global-set-key (kbd "C-c a l c") #'calc)
(global-set-key (kbd "C-c f")   #'find-file-at-point)
(global-set-key (kbd "C-c i")   #'imenu)
(global-set-key (kbd "C-c g") #'magit-status)

;; -------------------------------------------------------------------------------------------------

;; Enabling "advanced" built-in Emacs functionality

;;(put 'downcase-region 'disabled nil) 
;;(put 'upcase-region   'disabled nil)
;;
;; ^ Disabled again, I mistakenly used this feature, destroyed some case-sensitive URL data, and
;;   committed the destroyed information to disk, only realizing what I had done several days later.

(put 'set-goal-column 'disabled nil)
(put 'narrow-to-region 'disabled nil)

;; -------------------------------------------------------------------------------------------------

;; This is the first Emacs function that I wrote myself which I actually use regularly.

(defun rename-current-buffer (new-bufname)
  "Prompts for a new buffer name in the minibuffer using the
current buffer name as an initial value, renames the current
buffer to the value entered."
  (interactive
   (let ((curbufname (buffer-name)))
     (list (read-string "New buffer name: " curbufname 'buffer-name-history curbufname t))))
    (rename-buffer new-bufname))

(global-set-key (kbd "C-c b r") 'rename-current-buffer)

;; -------------------------------------------------------------------------------------------------

;; Source: https://stackoverflow.com/a/18317181

(defun my-find-file-check-make-large-file-read-only-hook ()
  "If a file is over a given size, make the buffer read only."
  (when (> (buffer-size) (* 1024 1024))
    (setq buffer-read-only t)
    (buffer-disable-undo)
    (fundamental-mode)))

(add-hook 'find-file-hook 'my-find-file-check-make-large-file-read-only-hook)

;; -------------------------------------------------------------------------------------------------

(require 'package)

(setq package-archives
  '(("gnu"   . "http://elpa.gnu.org/packages/")
    ("melpa" . "https://melpa.org/packages/")))

(package-initialize)

;; -------------------------------------------------------------------------------------------------

(require 'dired)

(setq dired-listing-switches "-Alt")

(defun my-dired-buffer-selected ()
  (interactive)
  (dolist (x (dired-get-marked-files)) (find-file-noselect x)))

(add-hook 'dired-load-hook
  (lambda ()
    (load "dired-x")))

(add-hook 'dired-mode-hook
  (lambda ()
    (progn
      (local-set-key (kbd "C-k")   'dired-kill-subdir)
      (local-set-key (kbd "C-c d o") 'my-dired-buffer-selected)
      (local-set-key (kbd "C-c w d") 'wdired-change-to-wdired-mode))))

;; -------------------------------------------------------------------------------------------------

(require 'erc)
(setq erc-email-userid "ramin_hal9001")
(setq erc-nick         "ramin_hal9001")

;; -------------------------------------------------------------------------------------------------

(require 'gnus)
(setq mail-sources '((file)))
(setq gnus-select-method '(nnmbox))

;; -------------------------------------------------------------------------------------------------

(load "/town/src/shadowland/clients/emacs/bbj.el")
(global-set-key (kbd "C-c b b j") 'bbj-browse-index)
